unit DemoSource;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, isdnobj, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    ISDNManager1: TISDNManager;
    ISDNLine1: TISDNLine;
    ISDNDevice1: TISDNDevice;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Edit2: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    AnswerCheckbox: TCheckBox;
    Button2: TButton;
    Label6: TLabel;
    StateLabel: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Timer1: TTimer;
    ProgressBar: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure AnswerCheckboxClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ISDNManager1Error(Sender: TComponent; Code1, Code2: Word;
      ConID: Integer);
    procedure ISDNLine1Disconnect(Line: TISDNLine; Reason: Word);
    procedure ISDNLine1IncomingCall(Line: TISDNLine;
      var Action: TRejectValue);
    procedure ISDNDevice1Connect(Device: TISDNDevice);
    procedure ISDNDevice1FileSent(Device: TISDNDevice; Info: Word);
    procedure ISDNLine1StateChange(Line: TISDNLine);
    procedure ErrorHandler(Value:TInfoValue);
    procedure Timer1Timer(Sender: TObject);
    procedure ISDNDevice1FileProgress(Device: TISDNDevice; const BytesSent,
      Percent: Integer);
    procedure ISDNDevice1Disconnect(Device: TISDNDevice; Reason: Word);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ErrorHandler(Value:TInfoValue);
begin
    If Value <> 0 then ShowMessage('ERROR !'+#13+#13+InfoToStr(Value));
end;


procedure TForm1.Button1Click(Sender: TObject);
var Info:TInfoValue;
begin
    ISDNLine1.CalledMSN.Number:=Edit2.Text;
    ErrorHandler(ISDNLine1.Connect);
end;

procedure TForm1.AnswerCheckboxClick(Sender: TObject);
begin
   If AnswerCheckbox.Checked then begin
       ISDNLine1.CallResponse.MSNs.Clear;
       ISDNLine1.CallResponse.MSNs.Add(Edit1.Text);
   end else begin
      ISDNLine1.CallResponse.MSNs.Clear;
   end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    ErrorHandler(ISDNLine1.Disconnect);
end;

procedure TForm1.ISDNManager1Error(Sender: TComponent; Code1, Code2: Word;
  ConID: Integer);
begin
    ShowMessage('A SERIOUS ERROR OCCURED !');
end;

procedure TForm1.ISDNLine1Disconnect(Line: TISDNLine; Reason: Word);
begin
    ShowMessage('DISCONNECT !'+#13+#13+'Reason: '+InfoToStr(Reason));
end;

procedure TForm1.ISDNLine1IncomingCall(Line: TISDNLine;
  var Action: TRejectValue);
begin
    if MessageDlg('INCOMING CALL !'+#13+#13+'MSN: '+Line.CallerParams.CallingNumber.Number+#13+#13+
               'Accept Call ?', mtInformation, [mbYes, mbNo], 0) = mrYes
    then Action := rvAccept else Action := rvReject;
end;

procedure TForm1.ISDNDevice1Connect(Device: TISDNDevice);
begin
    ErrorHandler(ISDNDevice1.SendWave('testmsg.wav',TRUE));
end;

procedure TForm1.ISDNDevice1FileSent(Device: TISDNDevice; Info: Word);
begin
    ErrorHandler(ISDNDevice1.ReceiveWave('recmsg.wav',TRUE));
end;

procedure TForm1.ISDNLine1StateChange(Line: TISDNLine);
begin
    StateLabel.Caption := ConnectionStateString[Line.State];
end;


procedure TForm1.Timer1Timer(Sender: TObject);
begin
    IF ISDNDevice1.Connected then begin
        Label7.Caption := 'Tx: '+IntToStr(ISDNDevice1.TransmitRate);
        Label8.Caption := 'Rx: '+IntToStr(ISDNDevice1.ReceiveRate);
    end;
end;

procedure TForm1.ISDNDevice1FileProgress(Device: TISDNDevice;
  const BytesSent, Percent: Integer);
begin
    ProgressBar.Position := Percent;
end;

procedure TForm1.ISDNDevice1Disconnect(Device: TISDNDevice; Reason: Word);
begin
    ProgressBar.Position:=0;
end;

end.
