unit callmonitor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, isdnobj, ComCtrls, Menus, TrayIcon;

const LogFileName = 'ISDNCalls.txt';

type
  TForm1 = class(TForm)
    TrayIcon: TTrayIcon;
    PopupMenu1: TPopupMenu;
    Properties1: TMenuItem;
    N1: TMenuItem;
    SwitchLabel: TMenuItem;
    CheckBox1: TCheckBox;
    ListView: TListView;
    Label1: TLabel;
    ISDNManager1: TISDNManager;
    ISDNLine1: TISDNLine;
    Button1: TButton;
    ImageList1: TImageList;
    N2: TMenuItem;
    Exit1: TMenuItem;
    procedure ISDNLine1IncomingCall(Line: TISDNLine;
      var Action: TRejectValue);
    procedure CheckBox1Click(Sender: TObject);
    procedure Properties1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SwitchLabelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1        : TForm1;
  WriteLog     : Boolean;
  EnabledState : Boolean = TRUE;
  First        : Boolean = TRUE;

implementation

{$R *.DFM}

procedure TForm1.ISDNLine1IncomingCall(Line: TISDNLine;
  var Action: TRejectValue);
Var Item : TListItem;
    LogFile : TextFile;
begin
    // NOTE: You dont need a ISDNDevice because a call
    // will never be established. (Action:=rvIgnore)
    Action := rvIgnore; // do not affect call
    Item := ListView.Items.Add;
    Item.Caption := Line.CallerParams.CallingNumber.Number;
    If Item.Caption='' then Item.Caption := 'unknown';
    Item.SubItems.Add(Line.CallerParams.CalledNumber.Number);
    Item.SubItems.Add(TimeToStr(Time));
    Item.SubItems.Add(DateToStr(Date));
    Item.SubItems.Add(ServiceString[Line.CallerParams.Service]);
    If WriteLog then begin
        AssignFile(LogFile,LogFileName);
        If FileExists(LogFileName) then Append(LogFile)
                                   else Rewrite(LogFile);
        WriteLn(LogFile,Item.Caption+#9+Item.SubItems[0]+#9+Item.SubItems[1]+#9+Item.SubItems[2]+#9+Item.SubItems[3]);
        CloseFile(LogFile);
    end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
    WriteLog := CheckBox1.Checked;
end;

procedure TForm1.Properties1Click(Sender: TObject);
begin
    Show;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    Hide;
end;
procedure TForm1.SwitchLabelClick(Sender: TObject);
begin
    If EnabledState then begin
        EnabledState:=FALSE;
        ImageList1.GetIcon(1,TrayIcon.Icon);
        SwitchLabel.Caption := 'Enable';
        TrayIcon.ToolTip := 'ISDN-CallMonitor [DISABLED]';
    end else begin
        EnabledState:=TRUE;
        ImageList1.GetIcon(0,TrayIcon.Icon);
        SwitchLabel.Caption := 'Disable';
        TrayIcon.ToolTip := 'ISDN-CallMonitor';
    end;
    TrayIcon.Active:=FALSE;
    TrayIcon.Active:=TRUE;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

  //
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
    Application.Terminate;
end;

procedure TForm1.FormHide(Sender: TObject);
begin
    ShowWindow(Application.Handle,SW_HIDE);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
    If First then begin
        First := FALSE;
        Hide;
    end;

end;

end.
